<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id: i_file_upload.php 543 2010-04-05 13:34:37Z balu $ */
if (!defined('CPO')) exit;

$fileoverwrite = array();
$uploadErrors = array(
    __('File was successfully uploaded.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The uploaded file exceeds the allowed size.'),
    __('Note: The file was not uploaded completely. Please try again.'),
    __('Note: No file was received. Please try again.')
);
$imageTypes = array(
    'unknown', 
    'GIF', 
    'JPG', 
    'PNG', 
    'SWF', 
    'PSD', 
    'BMP', 
    'TIFF(intel byte order)', 
    'TIFF(motorola byte order)', 
    'JPC', 
    'JP2', 
    'JPX', 
    'JB2', 
    'SWC', 
    'IFF');

?>

<?php 
if (!isset($_FILES['uppedFiles'])){
    ?>
    <form
        action="<?php echo $_SERVER['PHP_SELF']; ?>"
        method="post"
        enctype="multipart/form-data">
    <table class="colored" style="width: 100%;">
    <thead><tr>
        <th colspan="2"><span><?php echo __('File selection'); ?></span></th>
    </tr>
    </thead><tbody>
    <tr>
        <td class="leftrow"><?php echo __('Available in:'); ?></td>
        <td class="rightrow"> 
            <input type="hidden" name="MAX_FILE_SIZE" value="<?php print($cpoSystem['max_file']>$cpoSystem['max_image'] ? $cpoSystem['max_file'] : $cpoSystem['max_image']); ?>">
            <?php 
            if (!empty($_SESSION['SID_rubric_id']) && $_SESSION['SID_stufe3']) {
                print('<input type="radio" name="filerubrik" id="filerubrik" value="'.$_SESSION['SID_rubric_id'].'" checked>'.sprintf(__('this rubric (%s)'), $_SESSION['SID_rubric_name']).help('files-uploadfiles.html#files-uploadfiles-inthisrubric').'<br />');
                print('<input type="radio" name="filerubrik" id="filerubrik" value="-1">'.__('all rubrics').help('files-uploadfiles.html#files-uploadfiles-inallrubrics').'<br />');
            } else {
                print('<input type="radio" name="filerubrik" id="filerubrik" value="-1" checked>'.__('all rubrics').help('files-uploadfiles.html#files-uploadfiles-inallrubrics').'<br />');
            }


            if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                print('<input type="radio" name="filerubrik" id="filerubrik" value="-2">'.__('article-templates').help('files-uploadfiles.html#files-uploadfiles-inarticletemplates').'<br />');;
            }

            if (empty($_SESSION['SID_rubric_id'])) {
                print('<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '); 
                print(__('To upload files only available in one rubric please select the rubric first.').'<br />'); 
            }

            for ($a=1; $a<=$cpoSystem['noOfUploadFiles']; $a++) { ?>
                </td>
                </tr><tr>
                <td><?php printf (__('File %s:'), $a); ?></td>
                <td>
                    <input type="file" name="uppedFiles[]" size="80" /><?php echo help('files-uploadfiles.html#files-uploadfiles-filen'); ?>
            <?php } ?>
            <br /><br />
            <?php print('<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '); ?>
            <?php print(__('Please make sure that you have chosen <em>File-Type: all files (*.*)</em> in the browse window to have all files listed.')); ?>
        </td>
    </tr><tr>
        <td>&nbsp;</td>
        <td>
            <input type="submit" class="button" value="<?php print(__('upload files')); ?>" />
			<input type="checkbox" name="fileoverwrite" value="true" /> <?php echo __('overwrite'); ?>
        </td>
    </tr>
    </tbody>
    </table></form>
    <?php 
    return;
} // if (!isset($_FILES['uppedFiles'])){

$upped  = false;
for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
    if ($_FILES['uppedFiles']['name'][$i]=='') continue;
    $upped = true;
    break;
}
if (!$upped) {
    $message[] = ___('No file was uploaded.');
    $message[] = '<a href="'.BASE_REL.'_admin/upload_files.php">'.__('Upload more files &raquo;').'</a>';
    include(CPO_BASEDIR.'_include/message.php');
    return;
}
?>
<table class="colored" style="width: 100%;">
<thead><tr>
    <th colspan="2"><span><?php echo __('Uploaded files'); ?></span></th>
</tr>
</thead><tbody>
<?php
for($i=0; $i<count($_FILES['uppedFiles']['size']); $i++) {
    if ($_FILES['uppedFiles']['name'][$i]=='') {
        continue;
    }
    ?>
    <tr>
        <td class="leftrow"><?php echo htmlspecialchars($_FILES['uppedFiles']['name'][$i]); ?></td>
        <td class="rightrow"> 
    <?php

    // check for errors
    if (!$_FILES['uppedFiles']['size'][$i]) {
        if (isset($_FILES['uppedFiles']['error'][$i])) // this exists since PHP 4.2
             $error = $uploadErrors[$_FILES['uppedFiles']['error'][$i]];
        // else guess the error...
        else $error = __('Unknown ERROR: Please check if the size of the file exceeds the maximum uploadable file size.');

        printf(___('ERROR: There was an error: %s').'<br />', 
            htmlspecialchars($error)
        );
        continue;
     }

    // upload ok
    $path = CPO_BASEDIR.'_data/';

    // modify filename to exclude characters that are not a-z A-Z 0-9 _ or .
    $filename = $_FILES['uppedFiles']['name'][$i];
    $filename = preg_replace('/[^a-z0-9_\.-]/i', '_', $filename);

	
	// add a prefix if file exists
    $prefix = ''; 
    $prefixNo = 0;
    if ($_POST['fileoverwrite']==true && file_exists($path.$filename)) {
		$db = new DB;
        $db->query("SELECT id, beschreibung FROM ".CPO_DATA." WHERE datei='".$filename."' ");
		$db->next_record();
		$updatefileid = $db->v('id');
		$updatefiledesc = $db->v('beschreibung');
		unlink ($path.$filename);
		$fileoverwrite[$filename]=true;
	}
    while (file_exists($path.$prefix.$filename)) {
        $prefixNo++;
        $prefix = $prefixNo.'-';
    }
    $new_filename = $path.$prefix.$filename;

    if (file_exists($path.$filename)) {
        printf(__('This file did already exist.<br />To avoid overwriting the old file, a prefix got added: <em>%s</em>.').'<br />',
            $prefix);
    }


    // move the uploaded file to the new place
    if (!@move_uploaded_file($_FILES['uppedFiles']['tmp_name'][$i], $new_filename)) {
        // FIXME: warning-Bild
        printf(__('Unable to move the file <em>%s</em>! Make sure the webserver has write-access to the directory <em>%s</em>').'<br />',
            htmlspecialchars($new_filename),
            htmlspecialchars(dirname($new_filename))
        );
        continue;
    }
    @chmod($new_filename, 0666);

    // Check if it is an image suitable for web pages
    $checkImage = @getimagesize($new_filename);
    if ($checkImage && (
        $imageTypes[$checkImage[2]]=='JPG' || 
        $imageTypes[$checkImage[2]]=='PNG' ||
        $imageTypes[$checkImage[2]]=='GIF')) {

        // if the image-file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_image']) {
            @unlink($new_filename);
            printf(___('The file was %s bigger than the allowed maximum size of %s for images. Because of that the file was deleted. Please contact your administrator if you think this is an error.'),
                '<em>'.printHumanReadable($cpoSystem['max_image']-$_FILES['uppedFiles']['size'][$i]).'</em>',
                '<em>'.printHumanReadable($cpoSystem['max_image']).'</em>'
            );
            print('<br />');
            continue;
        }
        printf(__('The file is an image of type <em>%s</em> and is suitable for webpages.').'<br />',
            $imageTypes[$checkImage[2]]);
	    if ($_POST['fileoverwrite']==true && $fileoverwrite[$filename]) {
        $query = "REPLACE INTO ".CPO_DATA." SET "
                ." id='".$updatefileid."', "
                ." beschreibung='".$updatefiledesc."', "
                ." alttext='', "
                ." datum='".date('Y-m-d H:i:s', time())."', "
                ." type='".$_FILES['uppedFiles']['type'][$i]."', "
                ." datei='".$filename."', "
                ." format='2', "
                ." user_id='".$_SESSION['SID_user']['id']."', "
                ." rubric_id='".$_POST['filerubrik']."', "
                ." c_time='".date('Y-m-d H:i:s', time())."', "
                ." changer='".$_SESSION['SID_login']."' ";

		} else {
        $query = "INSERT INTO ".CPO_DATA." ("
                ."beschreibung, alttext, datum, type, datei, format, user_id, rubric_id, c_time, changer) "
                ."VALUES ("
                ."'', "
                ."'', "
                ."'".date('Y-m-d H:i:s', time())."', "
                ."'".$_FILES['uppedFiles']['type'][$i]."', "
                ."'".$prefix.$filename."', "
                ."'2', "
                ."'".$_SESSION['SID_user']['id']."', "
                ."'".$_POST['filerubrik']."', "
                ."'".date('Y-m-d H:i:s', time())."', "
                ."'".$_SESSION['SID_login']."')";
		}
    } else {
        // no image 

        // if the file is too big, delete it and continue
        if ($_FILES['uppedFiles']['size'][$i] > $cpoSystem['max_file']) {
            @unlink($new_filename);
            printf(__('The file was %s bigger than the allowed maximum size of %s for data files. Because of that the file was deleted. Please contact your administrator if you think this is an error.'),
                '<em>'.printHumanReadable($cpoSystem['max_file']-$_FILES['uppedFiles']['size'][$i]).'</em>',
                '<em>'.printHumanReadable($cpoSystem['max_file']).'</em>'
            );
            echo '<br />';
            continue;
        }

        printf(__('The file is a data file.').'<br />');
	    if ($_POST['fileoverwrite']==true && $fileoverwrite[$filename]) {
        $query = "REPLACE INTO ".CPO_DATA." SET "
                ." id='".$updatefileid."', "
                ." beschreibung='".$updatefiledesc."', "
                ." alttext='', "
                ." datum='".date('Y-m-d H:i:s', time())."', "
                ." type='".$_FILES['uppedFiles']['type'][$i]."', "
                ." datei='".$filename."', "
                ." format='1', "
                ." user_id='".$_SESSION['SID_user']['id']."', "
                ." rubric_id='".$_POST['filerubrik']."', "
                ." c_time='".date('Y-m-d H:i:s', time())."', "
                ." changer='".$_SESSION['SID_login']."' ";

		} else {
        $query = "INSERT INTO ".CPO_DATA." ("
            ."beschreibung, alttext, datum, type, datei, format, user_id, rubric_id, c_time, changer) values("
            ."'', "                    // beschreibung
            ."'', "                                 // alttext
            ."'".date('Y-m-d H:i:s', time())."', "  // datum
            ."'".$_FILES['uppedFiles']['type'][$i]."', " // type
            ."'".$prefix.$filename."', "            // datei
            ."'1', "                             // format
            ."'".$_SESSION['SID_user']['id']."', "     // user_id
            ."'".$_POST['filerubrik']."', "         // rubric_id
            ."'".date('Y-m-d H:i:s', time())."', "  // c_time
            ."'".$_SESSION['SID_login']."')";       // changer
		}
    }
    // store in database
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query);

    printf(__('File was uploaded and saved as <em>%s</em>.').'<br />'.
           __('The file has a size of <em>%s</em>.').'<br />',
        htmlspecialchars($prefix.$filename),
        printHumanReadable($_FILES['uppedFiles']['size'][$i]));
    print('</td></tr>');
    logaction('upload file', $prefix.$filename);
}
print('<tr><td>&nbsp;</td><td><a href="'.BASE_REL.'_admin/upload_files.php">'.__('Upload more files &raquo;').'</a>');
print('</tbody></table>');
?>
